/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsAudioMixerFilter_h__
#define __fsAudioMixerFilter_h__
//------------------------------------------------------------------------------
#include <fs/fsCommon/fsFilter.h>

#include <initguid.h>
#include <flTypes/flUIDs.h>
#include <flTypes/IAudioMixer.h>
//------------------------------------------------------------------------------
class fsAudioMixerFilter;
typedef mxObjectPtr<fsAudioMixerFilter>	fsAudioMixerFilterPtr;
//------------------------------------------------------------------------------
class FSCOMMONCLASS fsAudioMixerFilter : public fsFilter
{
	MXOBJECTHEADER(fsAudioMixerFilter, fsFilter);

public:
	fsAudioMixerFilter(const mxString& name);

protected:
	virtual ~fsAudioMixerFilter();

public:
	void		setBufferSize(mxUInt size);
	mxUInt		getBufferSize() const;
	mxBool		isMixing() const;

protected:
	IAudioMixer*		_audioMixer;
};
//------------------------------------------------------------------------------
//DECLARE_SAFE_COPYFUNC(fsAudioMixerFilterPtr);
//DECLARE_SAFE_COMPFUNC(fsAudioMixerFilterPtr);
//------------------------------------------------------------------------------
#endif //__fsAudioMixerFilter_h__
