/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsAudioRenderFilter_h__
#define __fsAudioRenderFilter_h__
//------------------------------------------------------------------------------
#include <fs/fsCommon/fsFilter.h>
//------------------------------------------------------------------------------
class fsAudioRenderFilter;
typedef mxObjectPtr<fsAudioRenderFilter>	fsAudioRenderFilterPtr;
//------------------------------------------------------------------------------
class FSCOMMONCLASS fsAudioRenderFilter : public fsFilter
{
	friend class fsFilterEnumerator;

	MXOBJECTHEADER(fsAudioRenderFilter, fsFilter);

protected:
	fsAudioRenderFilter(IBaseFilter* filter, const mxString& friendlyName);
	virtual ~fsAudioRenderFilter();

public:
	const mxString&	getFriendlyName() const;

protected:
	mxString		_friendlyName;
};
//------------------------------------------------------------------------------
//DECLARE_SAFE_COPYFUNC(fsAudioRenderFilterPtr);
//DECLARE_SAFE_COMPFUNC(fsAudioRenderFilterPtr);
//------------------------------------------------------------------------------
#endif //__fsAudioRenderFilter_h__
