/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#include "Stdafx.h"
#include <fs/fsCommon/fsEncoderFilter.h>
#include <assert.h>
//------------------------------------------------------------------------------
fsEncoderFilter::fsEncoderFilter(IBaseFilter* filter, const mxString& friendlyName) :
fsFilter(friendlyName)
{
	assert(filter != NULL);
	_filter			= filter;
	_friendlyName	= friendlyName;
}
//------------------------------------------------------------------------------
fsEncoderFilter::~fsEncoderFilter()
{
}
//------------------------------------------------------------------------------
const mxString&
fsEncoderFilter::getFriendlyName() const
{
	return _friendlyName;
}
//------------------------------------------------------------------------------
