/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsErrorMessage_h__
#define __fsErrorMessage_h__
//------------------------------------------------------------------------------
#include <mx/mxCore/mxString.h>
//------------------------------------------------------------------------------
class fsErrorMessage
{
public:
	enum TypeEnum
	{
		T_NONE,
		T_WRONG_CAPTURE,
		T_WRONG_ENCODER,
		T_WRONG_MEDIATYPE,
		T_NOTFOUND_DECODER,
		T_UNEXPECTED,

		NUM_TYPE
	};

public:
	fsErrorMessage()
	{
		Id		= 0;
		Type	= T_NONE;
		Message	= "";
	}

public:
	mxInt		Id;
	TypeEnum	Type;
	mxString	Message;
};
//------------------------------------------------------------------------------
#endif // __fsErrorMessage_h__
