/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsSourceFilter_h__
#define __fsSourceFilter_h__
//------------------------------------------------------------------------------
#include <fs/fsCommon/fsFilter.h>
//------------------------------------------------------------------------------
class fsSourceFilter;
typedef mxObjectPtr<fsSourceFilter>	fsSourceFilterPtr;
//------------------------------------------------------------------------------
class FSCOMMONCLASS fsSourceFilter : public fsFilter
{
	MXOBJECTHEADER(fsSourceFilter, fsFilter);

protected:
	fsSourceFilter(const mxString& friendlyName, const mxString& name);
	virtual ~fsSourceFilter();

public:
	const mxString&			getFriendlyName() const;

	virtual mxUInt			getNumPropertyPages() const;
	virtual const mxString&	getPropertyPageName(mxUInt pageIndex) const;
	virtual mxBool			showPropertyPage(HWND windowHandle, mxUInt pageIndex);

protected:
	mxString				_friendlyName;
};
//------------------------------------------------------------------------------
//DECLARE_SAFE_COPYFUNC(fsSourceFilterPtr);
//DECLARE_SAFE_COMPFUNC(fsSourceFilterPtr);
//------------------------------------------------------------------------------
#endif //__fsSourceFilter_h__
