/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsVolumeIndicatorFilter_h__
#define __fsVolumeIndicatorFilter_h__
//------------------------------------------------------------------------------
#include <fs/fsCommon/fsFilter.h>

#include <initguid.h>
#include <flTypes/flUIDs.h>
#include <flTypes/IVolumeIndicator.h>
//------------------------------------------------------------------------------
class fsVolumeIndicatorFilter;
typedef mxObjectPtr<fsVolumeIndicatorFilter>	fsVolumeIndicatorFilterPtr;
//------------------------------------------------------------------------------
class FSCOMMONCLASS fsVolumeIndicatorFilter : public fsFilter
{
	MXOBJECTHEADER(fsVolumeIndicatorFilter, fsFilter);

public:
	fsVolumeIndicatorFilter(const mxString& name);

protected:
	virtual ~fsVolumeIndicatorFilter();

public:
	void			getVolume(mxInt& left, mxInt& right) const;

	void			setEvaluationTime(mxULong evalTime);
	mxULong			getEvaluationTime() const;

protected:
	IVolumeIndicator*		_volumeIndicator;
};
//------------------------------------------------------------------------------
//DECLARE_SAFE_COPYFUNC(fsVolumeIndicatorFilterPtr);
//DECLARE_SAFE_COMPFUNC(fsVolumeIndicatorFilterPtr);
//------------------------------------------------------------------------------
#endif //__fsVolumeIndicatorFilter_h__
