#ifndef __Object_h__
#define __Object_h__
//------------------------------------------------------------------------------
#include <mx/mxCore/mxCore.h>
#include <mx/mxCore/mxString.h>
//------------------------------------------------------------------------------
class Object
{
public:
	Object();
	~Object();

public:
	void			setType(mxInt type);
	mxInt			getType() const;

	void			setSize(mxUInt width, mxUInt height);
	void			getSize(mxUInt& width, mxUInt& height) const;

	void			setName(const mxString& name);
	const mxString&	getName() const;

protected:
	mxInt		_type;
	mxUInt		_width;
	mxUInt		_height;
	mxString	_name;
};
//------------------------------------------------------------------------------
#endif
