//------------------------------------------------------------------------------
#ifndef __RInterface_h__
#define __RInterface_h__
//------------------------------------------------------------------------------
#include <fs/fsMulticastTools/fsRemoteInterface.h>
//------------------------------------------------------------------------------
class RInterface
{
public:
	RInterface();
	~RInterface();

public:
	void			setType(mxInt type);
	mxInt			getType() const;

	void			setSize(mxUInt width, mxUInt height);
	void			getSize(mxUInt& width, mxUInt& height) const;

	void			setName(const mxString& name);
	const mxString&	getName() const;

public:
	void	invokeNotify(const mxString& method);
	static void	invokeNotifyProc(const mxString& method, mxBool result, void *data);

protected:
	fsRemoteInterface*	_remoteInterface;
};
//------------------------------------------------------------------------------
#endif
