//------------------------------------------------------------------------------
#include "Stdafx.h"
#include <fs/fsConsoleTest/RObject.h>
#include <fs/fsCommon/fsCommon.h>
//------------------------------------------------------------------------------
RObject::RObject()
{
	_remoteObject = new fsRemoteObject(invokeProc, this);
//	_remoteObject->setPort(fsRemoteObject::PID_TRANSMIT, PORT_SENDER_REMOTEACK);
//	_remoteObject->setPort(fsRemoteObject::PID_RECEIVE, PORT_SENDER_REMOTE);
//	_remoteObject->setMaximumTransmissionRate(10 * 1024 * 1024);
//	_remoteObject->setTransmissionCount(2);
//	_remoteObject->setPacketSize(1024);
	_remoteObject->open();
}
//------------------------------------------------------------------------------
RObject::~RObject()
{
	_remoteObject = NULL;
}
//------------------------------------------------------------------------------
void
RObject::invoke(const mxString& method, fsInvokeData& param, fsInvokeData& retVal)
{
	if (method == "setType")
	{
		_object.setType(param.readInt());
	}
	else if (method == "getType")
	{
		retVal.writeInt(_object.getType());
	}
	else if (method == "setSize")
	{
		mxUInt size[2];
		param.readInt((mxInt *)size, 2);
		_object.setSize(size[0], size[1]);
	}
	else if (method == "getSize")
	{
		mxUInt size[2];
		_object.getSize(size[0], size[1]);
		retVal.writeInt((const mxInt *)size, 2);
	}
	else if (method == "setName")
	{
		_object.setName(param.readString());
	}
	else if (method == "getName")
	{
		retVal.writeString(_object.getName());
	}
}
//------------------------------------------------------------------------------
void
RObject::invokeProc(const mxString& method, fsInvokeData& param, fsInvokeData& retVal, void *data)
{
	RObject *robj = (RObject *)data;
	robj->invoke(method, param, retVal);
}
//------------------------------------------------------------------------------
