/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsKey_h__
#define __fsKey_h__
//------------------------------------------------------------------------------
#include <flNetwork/flNetwork.h>
#include <mx/mxCore/mxCore.h>
//------------------------------------------------------------------------------
#define KEY_LENGTH		8
//------------------------------------------------------------------------------
class fsKey
{
public:
	fsKey();
	~fsKey();

public:
	mxBool		operator ==(const fsKey& key) const;
	mxBool		operator !=(const fsKey& key) const;
	
	fsKey&		operator =(const fsKey& key);

public:
	static fsKey	createNewKey();

private:
	mxLong		_key[KEY_LENGTH];
};
//------------------------------------------------------------------------------
#endif //__fsKey_h__
