/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsMulticastDetectors_h__
#define __fsMulticastDetectors_h__
//------------------------------------------------------------------------------
#include <fs/fsMulticastTools/fsMulticastDetector.h>
#include <mx/mxCore/mxHash.h>
#include <mx/mxCore/mxString.h>
#include <mx/mxCore/mxObject.h>
//------------------------------------------------------------------------------
class fsMulticastDetectors;
typedef mxObjectPtr<fsMulticastDetectors>	fsMulticastDetectorsPtr;
//------------------------------------------------------------------------------
class FSMULTICASTTOOLSCLASS fsMulticastDetectors : public mxObject
{
	MXOBJECTHEADER(fsMulticastDetectors, mxObject);

public:
	fsMulticastDetectors();

protected:
	virtual ~fsMulticastDetectors();

public:
	mxBool			add(const mxString& address, mxUShort port);
	mxBool			remove(const mxString& address, mxUShort port);

public:
	mxBool			detected(const mxString& address, mxUShort port, mxULong evalTime = 1000) const;

protected:
	mxHashMap<mxString, fsMulticastDetectorPtr>	_detectors;
};
//------------------------------------------------------------------------------
#endif //__fsMulticastDetectors_h__
