/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#include "StdAfx.h"
#include <mx/mxCore/mxCriticalSection.h>
//------------------------------------------------------------------------------
mxCriticalSection::mxCriticalSection()
{
	InitializeCriticalSection(&_csection);
}
//------------------------------------------------------------------------------
mxCriticalSection::~mxCriticalSection()
{
	DeleteCriticalSection(&_csection);
}
//------------------------------------------------------------------------------
void
mxCriticalSection::enter() const
{
	EnterCriticalSection(&_csection);
}
//------------------------------------------------------------------------------
void
mxCriticalSection::leave() const
{
	LeaveCriticalSection(&_csection);
	Sleep(0);
}
//------------------------------------------------------------------------------
