/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#include "StdAfx.h"
#include <mx/mxCore/mxHandle.h>
//------------------------------------------------------------------------------
mxHandle::mxHandle() :
_handle(INVALID_HANDLE_VALUE)
{
}
//------------------------------------------------------------------------------
mxHandle::mxHandle(HANDLE handle) :
_handle(handle)
{
}
//------------------------------------------------------------------------------
mxHandle::~mxHandle()
{
	close();
}
//------------------------------------------------------------------------------
void
mxHandle::close()
{
	if (isValid())
#ifdef _WIN32
		CloseHandle(_handle);
#else
		::close(_handle);
#endif
	_handle = INVALID_HANDLE_VALUE;
}
//------------------------------------------------------------------------------
