/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef	__mxHandle_h__
#define	__mxHandle_h__
//------------------------------------------------------------------------------
#include <mx/mxCore/mxCore.h>
//------------------------------------------------------------------------------
#ifndef _WIN32
#define	HANDLE					mxInt
#define	INVALID_HANDLE_VALUE	(-1)
#endif
//------------------------------------------------------------------------------
class MXCORECLASS mxHandle
{
public:
	mxHandle();
	mxHandle(HANDLE handle);
	virtual ~mxHandle();

public:
	void			setHandle(HANDLE handle);
	HANDLE			getHandle() const;
	mxBool			isValid() const;

	void			close();

public:
					operator HANDLE() const;

private:
	mxHandle(const mxHandle&);
	mxHandle& operator =(const mxHandle&);

protected:
	HANDLE			_handle;
};
//------------------------------------------------------------------------------
#include <mx/mxCore/mxHandle.inl>
//------------------------------------------------------------------------------
#endif	// !__mxHandle_h__
