/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------
#ifndef __Graph_h__
#define __Graph_h__
//---------------------------------------------------------------------------
#define MAX_DATA		2048
#define INVALID_POINT	INT_MAX
//---------------------------------------------------------------------------
class PACKAGE TGraph : public TObject
{
	typedef TObject		inherited;

__published:
	__property TColor	Color = { read = FColor, write = FColor, default = clLime };

public:
	__fastcall			TGraph();
	virtual __fastcall	~TGraph();

public:
	void __fastcall		Point(int value);
	void __fastcall		Clear();

	void __fastcall		Draw(TCanvas* Canvas, int w, int h, int step, int min, int max);

private:
	int __fastcall		GetPoint(int index);

private:
	int		FPosition;
	int		FData[MAX_DATA];

	TColor	FColor;
};
//---------------------------------------------------------------------------
#endif
