/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------
#ifndef __fsMultiReceiverLanguage_h__
#define	__fsMultiReceiverLanguage_h__
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include "ui/fsCommonUI/fsLanguage.h"
//---------------------------------------------------------------------------
// Dynamic word Definiation
enum DynamicWordEnum {
	DW_RECEIVEVIDEO,
	DW_STATUSRECEIVE,
	DW_STATUSSTOP,
	DW_AREYOUOK,
	DW_CONFIRM,
    DW_ERROR,
	DW_SOCKETERROR,
	DW_RECEIVEREXISTERROR,
	DW_ADDRECEIVERERROR,
	DW_REMOVERECEIVERERROR,
	DW_READINIFILEERROR,
	DW_WRITEINIFILEERROR,
    DW_REMOTEINVOKETIMEOUT,
	NUM_DYNAMICWORDS
};
//---------------------------------------------------------------------------
class fsMultiReceiverLanguage : public fsLanguage
{
public:
	fsMultiReceiverLanguage(TMenuItem* LanguageMenuItem);
    virtual ~fsMultiReceiverLanguage();

public:
	virtual const AnsiString& getDynamicWord(int id);

protected:
	virtual void	setupLanguage();
    virtual void	setupDefaultJapanese();
    virtual void	setupDefaultEnglish();

private:
	AnsiString		_dynamicWords[NUM_DYNAMICWORDS];
};
//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------
