/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "fsMainDataModule.h"
#include "fsMultiReceiverMainForm.h"
#include "fsReceiveMonitorForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TReceiveMonitorForm *ReceiveMonitorForm;
//---------------------------------------------------------------------------
__fastcall TReceiveMonitorForm::TReceiveMonitorForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall
TReceiveMonitorForm::FormShow(TObject *Sender)
{
	MainDataModule->ReceiveMonitorTimer->Enabled = true;

	checkSelectedVideo();
}
//---------------------------------------------------------------------------
void __fastcall
TReceiveMonitorForm::FormHide(TObject *Sender)
{
	MainDataModule->ReceiveMonitorTimer->Enabled = false;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void
TReceiveMonitorForm::checkSelectedVideo()
{
	int index = MainDataModule->getSelectedVideoIndex();

    if (index != -1)
    {
	    ReceiveRateVideoLabel->Caption =
    				MultiReceiverMainForm->_language->getDynamicWord(DW_RECEIVEVIDEO) +
                    AnsiString(index + 1);
        ReceiveRateVideoLabel->Enabled = true;
	}
    else
    {
	    ReceiveRateVideoLabel->Caption =
    				MultiReceiverMainForm->_language->getDynamicWord(DW_RECEIVEVIDEO);
        ReceiveRateVideoLabel->Enabled = false;
    }
}
//---------------------------------------------------------------------------
