/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------

/**
ActionUpdate()nhfsReceiverInterfacěďo͂ȂׂsȂB
tH[̏ԍXV́AtH[̕\ɈꊇčsB
**/

#include <vcl.h>
#pragma hdrstop

#include "fsMainDataModule.h"
#include "fsVersionInfoForm.h"
#include "fsPointerSettingForm.h"
#include "fsMulticastSettingForm.h"
#include "fsReceiveMonitorForm.h"
#include "fsReceiverMainForm.h"
#include "fsReceiverLanguage.h"
#include "fsReceiverCommandHistory.h"
#include <ui/fsCommonUI/fsVolumeIndicatorForm.h>
#include <ui/fsCommonUI/fsErrorMessageForm.h>
#include <fs/fsReceiverRemote/fsReceiverRemoteInterface.h>
#include <stdio.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainDataModule *MainDataModule;
//---------------------------------------------------------------------------
__fastcall TMainDataModule::TMainDataModule(TComponent* Owner)
	: TDataModule(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::DataModuleCreate(TObject *Sender)
{
    IniFileOpenDialog->DefaultExt	= AnsiString("ini");
    IniFileOpenDialog->Filter		= AnsiString("ݒt@C|*.ini");
    IniFileOpenDialog->Title		= "ݒt@CǍ";

    IniFileSaveDialog->DefaultExt	= AnsiString("ini");
    IniFileSaveDialog->Filter		= AnsiString("ݒt@C|*.ini");
    IniFileSaveDialog->Title		= "݂̐ݒۑ";

    _commandHistory				= new fsReceiverCommandHistory(
    											OperationHistoryBeginMenuItem,
                                                OperationHistoryEndMenuItem);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::DataModuleDestroy(TObject *Sender)
{
    delete _commandHistory;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
// Operation Action List
//
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::OperationActionExecute(TObject *Sender)
{
	_commandHistory->updateAll();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ReceiveOnOffActionExecute(TObject *Sender)
{
	fsReceiverSetStart(!fsReceiverGetStart());
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ReceiveOnOffActionUpdate(TObject *Sender)
{
	ReceiveOnOffAction->Caption = fsReceiverGetStart() ?
    			ReceiverMainForm->_language->getDynamicWord(DW_STOP) :
                ReceiverMainForm->_language->getDynamicWord(DW_START);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::PointerTransmissionOnActionExecute(TObject *Sender)
{
	fsReceiverSetPointerTransmissionOn(!fsReceiverGetPointerTransmissionOn());
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::PointerTransmissionOnActionUpdate(TObject *Sender)
{
	PointerTransmissionOnAction->Checked = fsReceiverGetPointerTransmissionOn();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::RaiseOnActionExecute(TObject *Sender)
{
	fsReceiverSetRaiseOn(!fsReceiverGetRaiseOn());
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::RaiseOnActionUpdate(TObject *Sender)
{
	RaiseOnAction->Checked = fsReceiverGetRaiseOn();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::DrawLocusOnActionExecute(TObject *Sender)
{
	fsReceiverSetDrawLocusOn(!fsReceiverGetDrawLocusOn());
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::DrawLocusOnActionUpdate(TObject *Sender)
{
	DrawLocusOnAction->Checked = fsReceiverGetDrawLocusOn();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::WriteIniFileActionExecute(TObject *Sender)
{
    if (IniFileSaveDialog->Execute())
    {
        AnsiString filename = IniFileSaveDialog->FileName;
        if (fsReceiverWriteIniFile(filename.c_str()))
        {
        	_commandHistory->addWriteIniFile(filename);
        }
        else
        {
        	Application->MessageBox(
            	ReceiverMainForm->_language->getDynamicWord(DW_WRITEINIFILEERROR).c_str(),
                ReceiverMainForm->_language->getDynamicWord(DW_ERROR).c_str(),
                MB_OK | MB_ICONERROR);
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::WriteIniFileActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ReadIniFileActionExecute(TObject *Sender)
{
    if (IniFileOpenDialog->Execute())
    {
        AnsiString filename = IniFileOpenDialog->FileName;
        if (fsReceiverReadIniFile(filename.c_str()))
        {
        	_commandHistory->addReadIniFile(filename);
        }
        else
        {
        	Application->MessageBox(
            	ReceiverMainForm->_language->getDynamicWord(DW_READINIFILEERROR).c_str(),
                ReceiverMainForm->_language->getDynamicWord(DW_ERROR).c_str(),
                MB_OK | MB_ICONERROR);
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ReadIniFileActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ExitRemoteActionExecute(TObject *Sender)
{
	ReceiverTimer->Enabled = false;
	fsReceiverQuit();

    Sleep(1000);
    ReceiverTimer->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ExitActionExecute(TObject *Sender)
{
    ReceiverMainForm->Close();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ExitActionUpdate(TObject *Sender)
{
    //
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
// Show Action List
//
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ShowActionExecute(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::FitVideoToWindowActionExecute(TObject *Sender)
{
	fsReceiverSetVideoWindowPolicy(FSRECEIVER_FSVWP_FITTOWINDOW);
    fsReceiverComputeVideoWindow();

    _commandHistory->add((TAction *)Sender, P_SHOW);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::FitVideoToWindowActionUpdate(TObject *Sender)
{
	int vwp = fsReceiverGetVideoWindowPolicy();

    bool fitToWindow = (vwp == FSRECEIVER_FSVWP_FITTOWINDOW);
	FitVideoToWindowAction->Checked = fitToWindow;
	KeepVideoAspectAction->Enabled = fitToWindow;
	KeepVideoAspectAction->Checked = fitToWindow && fsReceiverGetKeepVideoAspect();

    bool orgSize = (vwp == FSRECEIVER_FSVWP_ORIGINALSIZE);
	OriginalVideoSizeAction->Checked = orgSize;
	FitWindowToVideoAction->Enabled = orgSize;
	FitWindowToVideoAction->Checked = orgSize && fsReceiverGetFitWindowToVideo();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::KeepVideoAspectActionExecute(TObject *Sender)
{
	fsReceiverSetKeepVideoAspect(!fsReceiverGetKeepVideoAspect());
    fsReceiverComputeVideoWindow();

    _commandHistory->add((TAction *)Sender, P_SHOW);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::KeepVideoAspectActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::OriginalVideoSizeActionExecute(TObject *Sender)
{
	fsReceiverSetVideoWindowPolicy(FSRECEIVER_FSVWP_ORIGINALSIZE);
    fsReceiverComputeVideoWindow();

    _commandHistory->add((TAction *)Sender, P_SHOW);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::OriginalVideoSizeActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::FitWindowToVideoActionExecute(TObject *Sender)
{
	fsReceiverSetFitWindowToVideo(!fsReceiverGetFitWindowToVideo());
    fsReceiverComputeVideoWindow();

    _commandHistory->add((TAction *)Sender, P_SHOW);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::FitWindowToVideoActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::VolumeIndicatorShowActionExecute(TObject *Sender)
{
	VolumeIndicatorForm->Show();
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
// Option Action List
//
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::OptionActionExecute(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::PointerActionExecute(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::PointerAutoConfigOnActionExecute(TObject *Sender)
{
	fsReceiverSetPointerAutomaticSetupOn(!fsReceiverGetPointerAutomaticSetupOn());

    _commandHistory->add((TAction *)Sender);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::PointerAutoConfigOnActionUpdate(TObject *Sender)
{
	PointerAutoConfigOnAction->Checked = fsReceiverGetPointerAutomaticSetupOn();
}
//---------------------------------------------------------------------------
// GeneralPointer
void __fastcall
TMainDataModule::GeneralPointerActionExecute(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::GeneralPointerNoneActionExecute(TObject *Sender)
{
	fsReceiverSetGeneralPointer(12345);

    _commandHistory->add((TAction *)Sender, P_GENERALPOINTER);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::GeneralPointerNoneActionUpdate(TObject *Sender)
{
	int generalPointer = fsReceiverGetGeneralPointer();
    bool pointerManual = !fsReceiverGetPointerAutomaticSetupOn();

	GeneralPointerNoneAction->Checked = (generalPointer == 12345);
	GeneralPointerNoneAction->Enabled = pointerManual;

	GeneralPointerStandardAction->Checked = (generalPointer == FSRECEIVER_FSGP_STANDARD);
	GeneralPointerStandardAction->Enabled = pointerManual;

	GeneralPointerArrowAction->Checked = (generalPointer == FSRECEIVER_FSGP_ARROW);
	GeneralPointerArrowAction->Enabled = pointerManual;

	GeneralPointerCircleAction->Checked = (generalPointer == FSRECEIVER_FSGP_CIRCLE);
	GeneralPointerCircleAction->Enabled = pointerManual;

	GeneralPointerRectangleAction->Checked = (generalPointer == FSRECEIVER_FSGP_RECTANGLE);
	GeneralPointerRectangleAction->Enabled = pointerManual;

	GeneralPointerTargetAction->Checked = (generalPointer == FSRECEIVER_FSGP_TARGET);
	GeneralPointerTargetAction->Enabled = pointerManual;

	GeneralPointerStarAction->Checked = (generalPointer == FSRECEIVER_FSGP_TARGET);
	GeneralPointerStarAction->Enabled = pointerManual;

	GeneralPointerDetailAction->Checked = (generalPointer == FSRECEIVER_FSGP_DETAILPOINTER);
	GeneralPointerDetailAction->Enabled = pointerManual;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::GeneralPointerStandardActionExecute(TObject *Sender)
{
	fsReceiverSetGeneralPointer(FSRECEIVER_FSGP_STANDARD);

    _commandHistory->add((TAction *)Sender, P_GENERALPOINTER);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::GeneralPointerStandardActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::GeneralPointerArrowActionExecute(TObject *Sender)
{
	fsReceiverSetGeneralPointer(FSRECEIVER_FSGP_ARROW);

    _commandHistory->add((TAction *)Sender, P_GENERALPOINTER);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::GeneralPointerArrowActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::GeneralPointerCircleActionExecute(TObject *Sender)
{
	fsReceiverSetGeneralPointer(FSRECEIVER_FSGP_CIRCLE);

    _commandHistory->add((TAction *)Sender, P_GENERALPOINTER);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::GeneralPointerCircleActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::GeneralPointerRectangleActionExecute(TObject *Sender)
{
	fsReceiverSetGeneralPointer(FSRECEIVER_FSGP_RECTANGLE);

    _commandHistory->add((TAction *)Sender, P_GENERALPOINTER);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::GeneralPointerRectangleActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::GeneralPointerTargetActionExecute(TObject *Sender)
{
	fsReceiverSetGeneralPointer(FSRECEIVER_FSGP_TARGET);

    _commandHistory->add((TAction *)Sender, P_GENERALPOINTER);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::GeneralPointerTargetActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::GeneralPointerStarActionExecute( TObject *Sender)
{
	fsReceiverSetGeneralPointer(FSRECEIVER_FSGP_STAR);

    _commandHistory->add((TAction *)Sender, P_GENERALPOINTER);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::GeneralPointerStarActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::GeneralPointerDetailActionExecute(TObject *Sender)
{
	fsReceiverSetGeneralPointer(FSRECEIVER_FSGP_DETAILPOINTER);

    _commandHistory->add((TAction *)Sender, P_GENERALPOINTER);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::GeneralPointerDetailActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
// RaisePointer
void __fastcall
TMainDataModule::RaisePointerActionExecute(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::RaisePointer1ActionExecute(TObject *Sender)
{
	fsReceiverSetRaisePointer(FSRECEIVER_FSRP_POINTER1);

    _commandHistory->add((TAction *)Sender, P_RAISEPOINTER);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::RaisePointer1ActionUpdate(TObject *Sender)
{
	int raisePointer = fsReceiverGetRaisePointer();
    bool pointerManual = !fsReceiverGetPointerAutomaticSetupOn();

	RaisePointer1Action->Checked = (raisePointer == FSRECEIVER_FSRP_POINTER1);
	RaisePointer1Action->Enabled = pointerManual;

	RaisePointer2Action->Checked = (raisePointer == FSRECEIVER_FSRP_POINTER2);
	RaisePointer2Action->Enabled = pointerManual;

	RaisePointer3Action->Checked = (raisePointer == FSRECEIVER_FSRP_POINTER3);
	RaisePointer3Action->Enabled = pointerManual;

	RaisePointerDetailAction->Checked = (raisePointer == FSRECEIVER_FSRP_DETAILPOINTER);
	RaisePointerDetailAction->Enabled = pointerManual;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::RaisePointer2ActionExecute(TObject *Sender)
{
	fsReceiverSetRaisePointer(FSRECEIVER_FSRP_POINTER2);

    _commandHistory->add((TAction *)Sender, P_RAISEPOINTER);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::RaisePointer2ActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::RaisePointer3ActionExecute(TObject *Sender)
{
	fsReceiverSetRaisePointer(FSRECEIVER_FSRP_POINTER3);

    _commandHistory->add((TAction *)Sender, P_RAISEPOINTER);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::RaisePointer3ActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::RaisePointerDetailActionExecute(TObject *Sender)
{
	fsReceiverSetRaisePointer(FSRECEIVER_FSRP_DETAILPOINTER);

    _commandHistory->add((TAction *)Sender, P_RAISEPOINTER);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::RaisePointerDetailActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
// LocusPointer
void __fastcall
TMainDataModule::LocusPointerActionExecute(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::LocusPointer1ActionExecute(TObject *Sender)
{
	fsReceiverSetLocusPointer(FSRECEIVER_FSLP_POINTER1);

    _commandHistory->add((TAction *)Sender, P_LOCUSPOINTER);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::LocusPointer1ActionUpdate(TObject *Sender)
{
	int locusPointer = fsReceiverGetLocusPointer();
    bool pointerManual = !fsReceiverGetPointerAutomaticSetupOn();

	LocusPointer1Action->Checked = (locusPointer == FSRECEIVER_FSLP_POINTER1);
	LocusPointer1Action->Enabled = pointerManual;

	LocusPointer2Action->Checked = (locusPointer == FSRECEIVER_FSLP_POINTER2);
	LocusPointer2Action->Enabled = pointerManual;

	LocusPointer3Action->Checked = (locusPointer == FSRECEIVER_FSLP_POINTER3);
	LocusPointer3Action->Enabled = pointerManual;

	LocusPointerDetailAction->Checked = (locusPointer == FSRECEIVER_FSLP_DETAILPOINTER);
	LocusPointerDetailAction->Enabled = pointerManual;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::LocusPointer2ActionExecute(TObject *Sender)
{
	fsReceiverSetLocusPointer(FSRECEIVER_FSLP_POINTER2);

    _commandHistory->add((TAction *)Sender, P_LOCUSPOINTER);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::LocusPointer2ActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::LocusPointer3ActionExecute(TObject *Sender)
{
	fsReceiverSetLocusPointer(FSRECEIVER_FSLP_POINTER3);

    _commandHistory->add((TAction *)Sender, P_LOCUSPOINTER);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::LocusPointer3ActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::LocusPointerDetailActionExecute(TObject *Sender)
{
	fsReceiverSetLocusPointer(FSRECEIVER_FSLP_DETAILPOINTER);

    _commandHistory->add((TAction *)Sender, P_LOCUSPOINTER);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::LocusPointerDetailActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::PointerSettingActionExecute(TObject *Sender)
{
	PointerSettingForm->ShowModal();

    _commandHistory->add((TAction *)Sender, P_POINTER);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::PointerSettingActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::MulticastActionExecute(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::MulticastSettingActionExecute(TObject *Sender)
{
    MulticastSettingForm->ShowModal();

    _commandHistory->add((TAction *)Sender, P_MULTICAST);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::MulticastSettingActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ReceiveMonitorShowActionExecute(TObject *Sender)
{
	ReceiveMonitorForm->Show();

    _commandHistory->add((TAction *)Sender, P_MULTICAST);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ReceiveMonitorShowActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
// Language
//
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::LanguageActionExecute(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
//
// VersionInfo Action List
//
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::HelpActionExecute(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::VersionInfoActionExecute(TObject *Sender)
{
	VersionInfoForm->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::VersionInfoActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
//
// PointerSetting Action List
//
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::PointerColorChooseActionExecute(TObject *Sender)
{
	if (ColorDialog->Execute())
    {
    	TColor color = ColorDialog->Color;
        int r = (color & 0x000000FF);
        int g = (color & 0x0000FF00) >> 8;
        int b = (color & 0x00FF0000) >> 16;

		PointerSettingForm->PointerColorREdit->Text = AnsiString(r);
		PointerSettingForm->PointerColorGEdit->Text = AnsiString(g);
		PointerSettingForm->PointerColorBEdit->Text = AnsiString(b);
    }
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::PointerCoordinateDesktopWindowActionExecute(TObject *Sender)
{
	fsReceiverSetPointerCoordinate(FSRECEIVER_FSC_DESKTOPWINDOW);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::PointerCoordinateDesktopWindowActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::PointerCoordinateVideoWindowActionExecute(TObject *Sender)
{
	fsReceiverSetPointerCoordinate(FSRECEIVER_FSC_VIDEOWINDOW);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::PointerCoordinateVideoWindowActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
//
// MulticastStting Action List
//
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::SynchronizeSenderAddressOnActionExecute(TObject *Sender)
{
	fsReceiverSetSynchronizeSenderAddressOn(
    		!fsReceiverGetSynchronizeSenderAddressOn());
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::SynchronizeSenderAddressOnActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::CreateIPv6AddressActionExecute(TObject *Sender)
{
	MulticastSettingForm->AddressEdit->Text = fsReceiverCreateIPv6Address();
    MulticastSettingForm->_addressIsDirty = true;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::CreateIPv6AddressActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::CreateIPv4AddressActionExecute(TObject *Sender)
{
	MulticastSettingForm->AddressEdit->Text = fsReceiverCreateIPv4Address();
    MulticastSettingForm->_addressIsDirty = true;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::CreateIPv4AddressActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::AddressUpdateActionExecute(TObject *Sender)
{
	AnsiString address = MulticastSettingForm->AddressEdit->Text;
    fsReceiverSetAddress(address.c_str());
    MulticastSettingForm->_addressIsDirty = false;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::AddressUpdateActionUpdate(TObject *Sender)
{
	AddressUpdateAction->Enabled =
    	(strlen(MulticastSettingForm->AddressEdit->Text.c_str()) != 0) &&
        MulticastSettingForm->_addressIsDirty;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TTLUpdateActionExecute(TObject *Sender)
{
	int ttl = MulticastSettingForm->TTLUpDown->Position;
    fsReceiverSetTimeToLive(ttl);
    MulticastSettingForm->_timeToLiveIsDirty = false;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TTLUpdateActionUpdate(TObject *Sender)
{
	TTLUpdateAction->Enabled = MulticastSettingForm->_timeToLiveIsDirty;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::AddRejectionAddressActionExecute(TObject *Sender)
{
	AnsiString address = fsReceiverGetCurrentReceiveAddress();
    if (address.Length() == 0)
    	return ;

    int index = MulticastSettingForm->RejectionAddressList->Items->IndexOf(address);
	if (index != -1)
    	return ;

    fsReceiverAddRejectionAddress(address.c_str());
    MulticastSettingForm->updateRejectionAddressList();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::AddRejectionAddressActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::RemoveRejectionAddressActionExecute(TObject *Sender)
{
	int index = MulticastSettingForm->RejectionAddressList->ItemIndex;
    if (index != -1)
    {
        fsReceiverRemoveRejectionAddress(index);
        MulticastSettingForm->updateRejectionAddressList();
    }
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::RemoveRejectionAddressActionUpdate(TObject *Sender)
{
	RemoveRejectionAddressAction->Enabled =
    			(MulticastSettingForm->RejectionAddressList->ItemIndex != -1);
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
// VersionInfo Action List
//
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::VersionInfoOKActionExecute(TObject *Sender)
{
	VersionInfoForm->Close();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::VersionInfoOKActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
// Receiver Timer
//
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ReceiverTimerTimer(TObject *Sender)
{
    fsLanguage *language = ReceiverMainForm->_language;

	bool valid = fsReceiverGetValid();

    // Update Status Bar
	if (ReceiverMainForm->_remoteInvokeTimeout)
    {
    	ReceiverMainForm->StatusBar->Panels->Items[0]->Text =
        	language->getDynamicWord(DW_REMOTEINVOKETIMEOUT);
        return ;
    }

    AnsiString text;

	bool receiveData	= fsReceiverReceiveSenderData();
    bool receiverStarted= fsReceiverGetStart();

	if (receiverStarted)
    {
    	if (receiveData)
        {
        	bool noData = true;

        	text = language->getDynamicWord(DW_STATUSRECEIVE) + ": ";
            if (fsReceiverReceiveVideo() && !(noData = false))
            	text += "("+language->getDynamicWord(DW_STATUSVIDEO)+")";
            if (fsReceiverReceiveAudio() && !(noData = false))
            	text += "(" + language->getDynamicWord(DW_STATUSAUDIO)+")";
            if (fsReceiverReceivePointerFocus() && !(noData = false))
            	text += "(" + language->getDynamicWord(DW_STATUSFOCUS)+")";

            if (noData)
            	text += "(" + language->getDynamicWord(DW_STATUSNODATA) + ")";
        }
        else
        {
        	text = language->getDynamicWord(DW_STATUSSTANDBY) + ": ";;
        }
    }
    else
    {
    	text = language->getDynamicWord(DW_STATUSSTOP) + ": ";;
    }
    ReceiverMainForm->StatusBar->Panels->Items[0]->Text = text;

    text = "";
    if (!valid)
    {
		text = language->getDynamicWord(DW_STATUSFAILEDCONFIG);

        int id, type;
        char message[128];
        fsReceiverGetErrorMessage(&id, &type, message);
        ErrorMessageForm->setError(id, type, message);
    }
    ReceiverMainForm->StatusBar->Panels->Items[1]->Text = text;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
// Receive Monitor Timer
//
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ReceiveMonitorTimerTimer(TObject *Sender)
{
    float receiveRate;
    int frameRate, dropPackets, dropFrames, packetSize;
    char str[256];

    receiveRate = float(fsReceiverGetVideoReceiverMainReceiveRate()) / 1024.0f;
    sprintf(str, "%5.3f", receiveRate);
    frameRate = fsReceiverGetVideoReceiverMainFrameRate();
    dropPackets = fsReceiverGetVideoReceiverMainNumDropPackets();
    dropFrames = fsReceiverGetVideoReceiverMainNumDropFrames();
    packetSize = fsReceiverGetVideoReceiverMainPacketSize();
    ReceiveMonitorForm->ReceiveRateVideoMainValue->Caption = AnsiString(str);
    ReceiveMonitorForm->FrameRateVideoMainValue->Caption = AnsiString(frameRate);
    ReceiveMonitorForm->DropPacketVideoMainValue->Caption = AnsiString(dropPackets);
    ReceiveMonitorForm->DropFrameVideoMainValue->Caption = AnsiString(dropFrames);
    ReceiveMonitorForm->PacketSizeVideoMainValue->Caption = AnsiString(packetSize);

    receiveRate = float(fsReceiverGetVideoReceiverSubReceiveRate()) / 1024.0f;
    sprintf(str, "%5.3f", receiveRate);
    frameRate = fsReceiverGetVideoReceiverSubFrameRate();
    dropPackets = fsReceiverGetVideoReceiverSubNumDropPackets();
    dropFrames = fsReceiverGetVideoReceiverSubNumDropFrames();
    packetSize = fsReceiverGetVideoReceiverSubPacketSize();
    ReceiveMonitorForm->ReceiveRateVideoSubValue->Caption = AnsiString(str);
    ReceiveMonitorForm->FrameRateVideoSubValue->Caption = AnsiString(frameRate);
    ReceiveMonitorForm->DropPacketVideoSubValue->Caption = AnsiString(dropPackets);
    ReceiveMonitorForm->DropFrameVideoSubValue->Caption = AnsiString(dropFrames);
    ReceiveMonitorForm->PacketSizeVideoSubValue->Caption = AnsiString(packetSize);

    receiveRate = float(fsReceiverGetAudioReceiverReceiveRate()) / 1024.0f;
    sprintf(str, "%5.3f", receiveRate);
    frameRate = fsReceiverGetAudioReceiverFrameRate();
    dropPackets = fsReceiverGetAudioReceiverNumDropPackets();
    dropFrames = fsReceiverGetAudioReceiverNumDropFrames();
    packetSize = fsReceiverGetAudioReceiverPacketSize();
    ReceiveMonitorForm->ReceiveRateAudioValue->Caption = AnsiString(str);
    ReceiveMonitorForm->FrameRateAudioValue->Caption = AnsiString(frameRate);
    ReceiveMonitorForm->DropPacketAudioValue->Caption = AnsiString(dropPackets);
    ReceiveMonitorForm->DropFrameAudioValue->Caption = AnsiString(dropFrames);
    ReceiveMonitorForm->PacketSizeAudioValue->Caption = AnsiString(packetSize);

    receiveRate = float(fsReceiverGetPointerFocusReceiverReceiveRate()) / 1024.0f;
    sprintf(str, "%5.3f", receiveRate);
    frameRate = fsReceiverGetPointerFocusReceiverFrameRate();
    dropPackets = fsReceiverGetPointerFocusReceiverNumDropPackets();
    dropFrames = fsReceiverGetPointerFocusReceiverNumDropFrames();
    packetSize = fsReceiverGetPointerFocusReceiverPacketSize();
    ReceiveMonitorForm->ReceiveRateFocusPointerValue->Caption = AnsiString(str);
    ReceiveMonitorForm->FrameRateFocusPointerValue->Caption = AnsiString(frameRate);
    ReceiveMonitorForm->DropPacketFocusPointerValue->Caption = AnsiString(dropPackets);
    ReceiveMonitorForm->DropFrameFocusPointerValue->Caption = AnsiString(dropFrames);
    ReceiveMonitorForm->PacketSizeFocusPointerValue->Caption = AnsiString(packetSize);

    receiveRate = float(fsReceiverGetPointerReceiverReceiveRate()) / 1024.0f;
    sprintf(str, "%5.3f", receiveRate);
    frameRate = fsReceiverGetPointerReceiverFrameRate();
    dropPackets = fsReceiverGetPointerReceiverNumDropPackets();
    dropFrames = fsReceiverGetPointerReceiverNumDropFrames();
    packetSize = fsReceiverGetPointerReceiverPacketSize();
    ReceiveMonitorForm->ReceiveRatePointerValue->Caption = AnsiString(str);
    ReceiveMonitorForm->FrameRatePointerValue->Caption = AnsiString(frameRate);
    ReceiveMonitorForm->DropPacketPointerValue->Caption = AnsiString(dropPackets);
    ReceiveMonitorForm->DropFramePointerValue->Caption = AnsiString(dropFrames);
    ReceiveMonitorForm->PacketSizePointerValue->Caption = AnsiString(packetSize);
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
// MulticastSetting Timer
//
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::MulticastSettingTimerTimer(TObject *Sender)
{
	// Update Multicast Detection
	AnsiString address = MulticastSettingForm->_inputAddress;
    MulticastSettingForm->MulticastDetectLabel->Visible =
    	(address.Length() != 0 && fsReceiverWasDetectedMulticast(address.c_str()));

    // Update Current IP Address
	MulticastSettingForm->CurrentAddressValueLabel->Caption
    					 = fsReceiverGetCurrentReceiveAddress();
}
//---------------------------------------------------------------------------

