/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------
#ifndef __fsReceiverCommandHistory_h__
#define __fsReceiverCommandHistory_h__
//---------------------------------------------------------------------------
#include <ui/fsCommonUI/fsCommandHistory.h>
//---------------------------------------------------------------------------
enum ReceiverPrefixIdEnum {
	P_SHOW,
    P_POINTER,
	P_GENERALPOINTER,
    P_RAISEPOINTER,
    P_LOCUSPOINTER,
   	P_MULTICAST,
    P_READINIFILE,
    P_WRITEINIFILE
};
//---------------------------------------------------------------------------
class fsReceiverCommandHistory : public fsCommandHistory
{
public:
	fsReceiverCommandHistory(TMenuItem* HistoryBeginMenuItem,
							TMenuItem* HistoryEndMenuItem);
    ~fsReceiverCommandHistory();

protected:
	AnsiString		getPrefixIdString(int prefixId);

public:
	void			addReadIniFile(const AnsiString& filename);
    void			addWriteIniFile(const AnsiString& filename);

private:
	void __fastcall	ReadIniFileMenuItemOnExecute(TObject *Sender);
	void __fastcall	WriteIniFileMenuItemOnExecute(TObject *Sender);
};
//---------------------------------------------------------------------------
#endif //__fsSenderCommandHistory_h__

 