/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------

#ifndef fsReceiverMainFormH
#define fsReceiverMainFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <Buttons.hpp>
//---------------------------------------------------------------------------
class fsLanguage;
//---------------------------------------------------------------------------
class TReceiverMainForm : public TForm
{
__published:	// IDE Ǘ̃R|[lg
	TPanel *VideoRenderPanel;
	TStatusBar *StatusBar;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall VideoRenderPanelResize(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall FormKeyUp(TObject *Sender, WORD &Key, TShiftState Shift);
private:	// [U[錾
public:		// [U[錾
	__fastcall TReceiverMainForm(TComponent* Owner);

	int __fastcall	ProcessCallback(const char *command, void *param);

	void __fastcall VolumeRequest(TObject *Sender, int *volume, int evalTime);

private:
	void			toCenter(TForm* form);

public:
	fsLanguage*	_language;
    bool		_forbidResize;
};
//---------------------------------------------------------------------------
extern PACKAGE TReceiverMainForm *ReceiverMainForm;
//---------------------------------------------------------------------------
#endif
