/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------

#ifndef fsCaptionSettingFormH
#define fsCaptionSettingFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
//---------------------------------------------------------------------------
class TCaptionSettingForm : public TForm
{
__published:	// IDE Ǘ̃R|[lg
	TButton *OKButton;
	TButton *CancelButton;
	TLabel *CaptionLabel;
	TEdit *CaptionEdit;
	TCheckBox *CaptionOffCheckBox;
	void __fastcall CaptionEditChange(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall CaptionEditKeyPress(TObject *Sender, char &Key);
	void __fastcall FormHide(TObject *Sender);
private:	// [U[錾
public:		// [U[錾
	__fastcall TCaptionSettingForm(TComponent* Owner);

public:
	void		updateForm();

public:
	bool		_captionIsDirty;
    bool		_captionOff;
    bool		_formShown;
};
//---------------------------------------------------------------------------
extern PACKAGE TCaptionSettingForm *CaptionSettingForm;
//---------------------------------------------------------------------------
#endif
