/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsAsyncReaderFilter_h__
#define __fsAsyncReaderFilter_h__
//------------------------------------------------------------------------------
#include <fs/fsCommon/fsSourceFilter.h>

#include <initguid.h>
#include <flTypes/flUIDs.h>
//------------------------------------------------------------------------------
class fsAsyncReaderFilter;
typedef mxObjectPtr<fsAsyncReaderFilter>	fsAsyncReaderFilterPtr;
//------------------------------------------------------------------------------
class FSCOMMONCLASS fsAsyncReaderFilter : public fsSourceFilter
{
	friend class fsFilterEnumerator;

	MXOBJECTHEADER(fsAsyncReaderFilter, fsSourceFilter);

public:
	fsAsyncReaderFilter(const mxString& name);

protected:
	virtual ~fsAsyncReaderFilter();

public:
	mxBool			load(const mxString& filename);

protected:
	IFileSourceFilter*	_fileSource;
};
//------------------------------------------------------------------------------
DECLARE_SAFE_COPYFUNC(fsAsyncReaderFilterPtr);
DECLARE_SAFE_COMPFUNC(fsAsyncReaderFilterPtr);
//------------------------------------------------------------------------------
#endif //__fsAsyncReaderFilter_h__
