/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#include "Stdafx.h"
#include <fs/fsCommon/fsAutoLock.h>
//------------------------------------------------------------------------------
fsAutoLock::fsAutoLock(const mxCriticalSection& criticalSection)
{
	_criticalSection = &criticalSection;
	_criticalSection->enter();
}
//------------------------------------------------------------------------------
fsAutoLock::~fsAutoLock()
{
	_criticalSection->leave();
}
//------------------------------------------------------------------------------
