/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsEncoderFilter_h__
#define __fsEncoderFilter_h__
//------------------------------------------------------------------------------
#include <fs/fsCommon/fsFilter.h>
//------------------------------------------------------------------------------
class fsEncoderFilter;
typedef mxObjectPtr<fsEncoderFilter>	fsEncoderFilterPtr;
//------------------------------------------------------------------------------
class FSCOMMONCLASS fsEncoderFilter : public fsFilter
{
	friend class fsFilterEnumerator;

	MXOBJECTHEADER(fsEncoderFilter, fsFilter);

protected:
	fsEncoderFilter(IBaseFilter *filter, const mxString& friendlyName);
	virtual ~fsEncoderFilter();

public:
	const mxString&	getFriendlyName() const;

protected:
	mxString		_friendlyName;
};
//------------------------------------------------------------------------------
//DECLARE_SAFE_COPYFUNC(fsEncoderFilterPtr);
//DECLARE_SAFE_COMPFUNC(fsEncoderFilterPtr);
//------------------------------------------------------------------------------
#endif //__fsEncoderFilter_h__
