/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsVideoExtractFilter_h__
#define __fsVideoExtractFilter_h__
//------------------------------------------------------------------------------
#include <fs/fsCommon/fsFilter.h>

#include <initguid.h>
#include <flTypes/flUIDs.h>
#include <flTypes/IVideoExtract.h>
//------------------------------------------------------------------------------
class fsVideoExtractFilter;
typedef mxObjectPtr<fsVideoExtractFilter>	fsVideoExtractFilterPtr;
//------------------------------------------------------------------------------
class FSCOMMONCLASS fsVideoExtractFilter : public fsFilter
{
	MXOBJECTHEADER(fsVideoExtractFilter, fsFilter);

public:
	fsVideoExtractFilter(const mxString& name);

protected:
	virtual ~fsVideoExtractFilter();

public:
	mxInt			getOutputVideoResolution() const;
	void			setOutputVideoResolution(mxInt videoResolution);

protected:
	IVideoExtract*		_videoExtract;
};
//------------------------------------------------------------------------------
//DECLARE_SAFE_COPYFUNC(fsVideoExtractFilterPtr);
//DECLARE_SAFE_COMPFUNC(fsVideoExtractFilterPtr);
//------------------------------------------------------------------------------
#endif //__fsVideoExtractFilter_h__
