//------------------------------------------------------------------------------
#ifndef __RObject_h__
#define __RObject_h__
//------------------------------------------------------------------------------
#include <fs/fsConsoleTest/Object.h>
#include <fs/fsMulticastTools/fsRemoteObject.h>
#include <fs/fsMulticastTools/fsInvokeData.h>
//------------------------------------------------------------------------------
class RObject
{
public:
	RObject();
	~RObject();

public:
	void invoke(const mxString& method, fsInvokeData& param, fsInvokeData& retVal);
	static void	invokeProc(const mxString& method, fsInvokeData& param, fsInvokeData& retVal, void *data);

protected:
	fsRemoteObject*	_remoteObject;
	Object			_object;
};
//------------------------------------------------------------------------------
#endif
