// fsConsoleTest.cpp : R\[ AvP[ṼGg |Cg`܂B
//



#include "stdafx.h"

#pragma comment(lib, "fsSender.lib")
#pragma comment(lib, "fsCommon.lib")
#pragma comment(lib, "fsStatus.lib")
#pragma comment(lib, "fsMulticastTools.lib")
#pragma comment(lib, "mxCore.lib")
#pragma comment(lib, "flNetwork.lib")
#pragma comment(lib, "flBase.lib")
#pragma comment(lib, "ws2_32.lib")
#pragma comment(lib, "winmm.lib")
#pragma comment(lib, "Strmiids.lib")

#include <fs/fsMulticastTools/fsMulticastAddress.h>
int _tmain(int argc, _TCHAR* argv[])
{
	mxInt b1, b2, b3, b4;
	
	mxInt c1[256], c2[256], c3[256], c4[256];

	memset(c1, 0, sizeof(c1));
	memset(c2, 0, sizeof(c2));
	memset(c3, 0, sizeof(c3));
	memset(c4, 0, sizeof(c4));


	for(mxUInt i = 0; i < 100000; i++)
	{
		mxString str = fsMulticastAddress::createAddress(fsMulticastAddress::AF_IPv4);
		sscanf(str.c_str(), "%d %d %d %d", &b1, &b2, &b3, &b4);

		c1[b1] ++;
		c2[b2] ++;
		c3[b3] ++;
		c4[b4] ++;
	}

	for(mxInt i = 0; i < 256; i++)
	{
		printf("[%d]  [%d].[%d].[%d].[%d]\n", i, c1[i], c2[i], c3[i], c4[i]);
	}

	getchar();
}


#if 0

#include <mx/mxCore/mxHash.h>
#include <mx/mxCore/mxObject.h>

class Test;
typedef mxObjectPtr<Test>	TestPtr;
class Test : public mxObject
{
	MXOBJECTHEADER(Test, mxObject);
public:
	Test()
	{
	}
protected:
	virtual ~Test()
	{
		int aaa = 1;
	}
};
DECLARE_SAFE_COPYFUNC(TestPtr);
DECLARE_SAFE_COMPFUNC(TestPtr);

int _tmain(int argc, _TCHAR* argv[])
{
	mxArray<TestPtr>	array;

	array.add(new Test());
	array.add(new Test());
	array.add(new Test());
	array.add(new Test());

	array.removeIndex(3);

	int aaa = 1;
}

#endif

#if 0
#include <fs/fsCommon/fsAutoLock.h>
#include <mx/mxCore/mxThread.h>
#include <mx/mxCore/mxnotify.h>

mxCriticalSection criticalSection;

mxUInt __stdcall threadProc1(void *data)
{
	while(true)
	{
		{
			mxNotify::post(mxNotify::INFO, "Thread 1 IN");

			fsAutoLock autoLock(criticalSection);
			Sleep(1000);

			mxNotify::post(mxNotify::INFO, "Thread 1 OUT");
		}
		Sleep(0);
	}
}

mxUInt __stdcall threadProc2(void *data)
{
	while(true)
	{
		{
			mxNotify::post(mxNotify::INFO, "Thread 2 IN");

			fsAutoLock autoLock(criticalSection);
			Sleep(1000);

			mxNotify::post(mxNotify::INFO, "Thread 2 OUT");
		}
		Sleep(0);
	}
}

int _tmain(int argc, _TCHAR* argv[])
{
	mxThread thread1 = new mxThread(threadProc1, NULL);
	mxThread thread2 = new mxThread(threadProc2, NULL);

	while(true)
		Sleep(1);
}
#endif

#if 0

#include <fs/fsCommon/fsStillPictureFilter.h>
#include <fs/fsCommon/fsVideoRenderFilter.h>
#include <fs/fsCommon/fsFilter.h>
#include <fs/fsCommon/fsGraphManager.h>
#include <initguid.h>
// LevelCompress Filter Object
// {F5B05DB1-C61D-4d93-96A4-21DBBEC35EB0}
DEFINE_GUID(CLSID_LevelCompress, 
0xf5b05db1, 0xc61d, 0x4d93, 0x96, 0xa4, 0x21, 0xdb, 0xbe, 0xc3, 0x5e, 0xb0);

//------------------------------------------------------------------------------
class fsTmpFilter;
typedef mxObjectPtr<fsTmpFilter>	fsTmpFilterPtr;
//------------------------------------------------------------------------------
class fsTmpFilter : public fsFilter
{
	MXOBJECTHEADER(fsTmpFilter, fsFilter);

public:
	fsTmpFilter(const mxString& name) : fsFilter(name)
	{
		HRESULT hr;
		hr = CoCreateInstance(CLSID_LevelCompress, NULL, CLSCTX_INPROC,
							IID_IBaseFilter, (void **)&_filter);

		if (hr != S_OK)
			_filter		= NULL;
	}

protected:
	virtual ~fsTmpFilter()
	{
	}
};
//------------------------------------------------------------------------------
int _tmain(int argc, _TCHAR* argv[])
{
	CoInitialize(NULL);

	fsGraphManagerPtr graph = new fsGraphManager(NULL, NULL, NULL, NULL);
	graph->initialize(true);

	fsStillPictureFilterPtr sp = new fsStillPictureFilter("StillPicture");
	sp->setFilename("D:\\Works\\NIME\\dshow\\031231Develop\\_images\\naruko.bmp");
	graph->addFilter(*sp);

	fsTmpFilterPtr tf = new fsTmpFilter("Tmp");
	graph->addFilter(*tf);
	graph->connectFilterDirect(*sp, 0, *tf, 0);

	fsVideoRenderFilterPtr vr = new fsVideoRenderFilter("Render");
	graph->addFilter(*vr);
	graph->connectFilterIndirect(*tf, 0, *vr, 0);

	graph->start();

	Sleep(300000);

	graph->stop();
	graph->removeAllFilters();

	sp = NULL;
	tf = NULL;
	vr = NULL;

	CoUninitialize();
}
//------------------------------------------------------------------------------

#endif

#if 0
#include <mx/mxCore/mxThread.h>
#include <mx/mxCore/mxSemaphore.h>


mxSemaphore *sem = NULL;

mxUInt __stdcall threadProc1(void *data)
{
	while(true)
	{
		sem->waitFor();
		printf("Thread1 Complete.\n");
		Sleep(1000);
		sem->release(1);
	}
}

mxUInt __stdcall threadProc2(void *data)
{
	while(true)
	{
		sem->waitFor();
		printf("Thread2 Complete.\n");
		Sleep(1000);
		sem->release(1);
	}
}

int _tmain(int argc, _TCHAR* argv[])
{
	sem = new mxSemaphore(1, 1);
	
	mxThread thread1 = new mxThread(threadProc1, NULL);
	mxThread thread2 = new mxThread(threadProc2, NULL);

	while(true)
		Sleep(1);
}
#endif

#if 0
//#include <mx/mxCore/mxArray.h>
#include <mx/mxCore/mxList.h>

class VVV
{
public:
	VVV()
	{
	}

	~VVV()
	{
		int aaa = 1;
	}

public:
	int a;
};

int _tmain(int argc, _TCHAR* argv[])
{

	mxList<VVV *> list;

	VVV *vvvv = NULL;

	for(mxUInt i = 0; i < 100; i++)
	{
		VVV *vvv = new VVV;
		vvv->a = i;
		list.add(vvv);

		if (i == 50)
			vvvv = vvv;
	}

	mxList<VVV *>::iterator it = list.begin();
	for(mxUInt i = 0; i < 5; i++)
	{
		delete *it;
		list.remove(*it++);
	}

	for(mxUInt i = 0; i < list.getSize(); i++)
		printf("list = %d\n", list[i]->a);

	getchar();
}

#endif

#if 0
//------------------------------------------------------------------------------
#include "RInterface.h"
#include "RObject.h"
//------------------------------------------------------------------------------
int _tmain(int argc, _TCHAR* argv[])
{
	mxInt which;

	printf("Interface(Setter):0 Interface(Getter):1 Object:2 ?");
	scanf("%d", &which);
	switch(which)
	{
	case 0:
		{
			const mxInt COUNT = 10000;
			RInterface rint;

			printf("Begin [%d times]\n", COUNT);
			mxULong startTime = GetTickCount();


			mxString names [] = { "Norio", "Mina", "Mao", "Kouki", "Yoriko", "Hironori" };

			for(mxUInt i = 0; i < COUNT; i++)
			{
				mxInt nameId = (rand() % 6);

				rint.setName(names[nameId]);
				const mxString& retName = rint.getName();

//				if (names[nameId] != retName)
//					printf("Different!! [%s] : %s\n", names[nameId].c_str(), retName.c_str());
				printf("[%s] : %s\n", names[nameId].c_str(), retName.c_str());

				Sleep(100);

//				mxInt type = rand();
//				rint.setType(type);
//
//				mxInt ttype = rint.getType();
//				if (type != ttype)
//					printf("Different [%d]:%d\n", type, ttype);
//				Sleep(0);
			}

			printf("End [%d]\n", (GetTickCount() - startTime));

			getchar();
			getchar();
		}
		break;
	case 1:
		{
			RInterface rint;

			for(mxUInt i = 0; i < 1000; i++)
			{
				printf("GetType:%d\n", rint.getType());
				getchar();
			}

			getchar();
			getchar();
		}
		break;
	case 2:
		{
			RObject robj;
			Sleep(1000000);
		}
		break;
	}
}
//------------------------------------------------------------------------------
#endif

//------------------------------------------------------------------------------
#if 0
int _tmain(int argc, _TCHAR* argv[])
{
	mxUInt vvv = mxString("fsMulticastControlUniqueID").hash();

	fsStatusSenderPtr ss = new fsStatusSender();
	ss->setAddress("234.5.6.7");
	ss->setTimeToLive(1);
	ss->setPort(8000);
	ss->setPacketSize(1024);
	mxBool flag = ss->open();

	fsStatus status;
	memset(&status, 0, sizeof(fsStatus));
	for(mxUInt i = 0; i < 1000; i++)
	{
		ss->send(status);
		Sleep(100);
	}

/*
	CoInitialize(NULL);

//	fsTempGraphManagerPtr graph = new fsTempGraphManager(NULL);
//	graph->initialize();
//
//	Sleep(1000);
//
//	graph->shutdown();
//	graph = NULL;

	fsSenderPtr sender = new fsSender();
	sender->initialize(NULL);
	Sleep(10000);
	sender->shutdown();

	CoUninitialize();
*/
}
#endif
//------------------------------------------------------------------------------

#if 0

#include <fs/fsMulticastTools/fsValueMediator.h>

fsValueMediatorPtr mediator;


void eventProc(fsValueMediator::EventTypeEnum eventType, void* eventParam, void* data)
{
	switch(eventType)
	{
	case fsValueMediator::E_RECEIVEVALUESTATUS:
		{
			printf("Receive Values Status ---------------------------\n");

			fsReceiveValueStatus *status = (fsReceiveValueStatus *)eventParam;

			printf("\t");
			for(mxUInt i = 0; i < status->NumValues; i++)
				printf("[%d] ", status->Values[i]);
			printf("\n");
		}
		break;

	case fsValueMediator::E_COLLIDEVALUE:
		{
			printf("Collide Value ---------------------------\n");

			mediator->setValue(fsValueMediator::getFreeValue(0, 100));

			printf("\tNew Own Value = %d\n", mediator->getValue());
		}
		break;

	case fsValueMediator::E_VALUEDETECTED:
		{
			//printf("<< New Value Detected. [%d] >>\n", (mxInt)eventParam);
		}
		break;

	case fsValueMediator::E_VALUELOST:
		{
			//printf("<< Value Lost. [%d] >>\n", (mxInt)eventParam);
		}
		break;
	}
}

int _tmain(int argc, _TCHAR* argv[])
{
	flNetwork::initialize();

	mediator = new fsValueMediator(eventProc, NULL);

	mediator->setAddress("234.5.6.7");
	mediator->setPort(9000);
	mediator->setTimeToLive(1);
	mediator->setPacketSize(1024);

	mediator->setValue(fsValueMediator::getFreeValue(0, 100));
	mediator->setNotifyInterval(1000);
	mediator->setReceiveLostInterval(5000);
	mediator->setEventBlankTimeInValueDetected(1000);
	mediator->setEventBlankTimeInValueLost(5000);


	printf("\nOwn Value = %d\n", mediator->getValue());

	printf("Begin Mediate\n");
	mediator->open();

	Sleep(600000);

	mediator->close();
	printf("End Mediate\n");

	mediator = NULL;

	flNetwork::shutdown();

	getchar();

	return 0;
}

#endif
