/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#include "Stdafx.h"
#include <fs/fsMultiReceiver/fsMultiReceiverSkelEx.h>
//------------------------------------------------------------------------------
fsMultiReceiverSkelEx::fsMultiReceiverSkelEx(fsMultiReceiverIf* multiReceiver) :
fsMultiReceiverSkel(multiReceiver)
{
}
//------------------------------------------------------------------------------
fsMultiReceiverSkelEx::~fsMultiReceiverSkelEx()
{
}
//------------------------------------------------------------------------------
void
fsMultiReceiverSkelEx::invoke(const mxString& method,
					   fsInvokeData& param,
					   fsInvokeData& retVal)
{
	inherited::invoke(method, param, retVal);

	if (method == "_property_Address")
	{
		const fsRMIPropertyPtr& property = _rObject->getProperty();
		property->setAddress(param.readString());
		_rObject->setProperty(property);
	}
	else if (method == "_property_TimeToLive")
	{
		const fsRMIPropertyPtr& property = _rObject->getProperty();
		property->setTimeToLive((mxULong)param.readInt());
		_rObject->setProperty(property);
	}
}
//------------------------------------------------------------------------------
