/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsMulticastAddress_h__
#define __fsMulticastAddress_h__
//------------------------------------------------------------------------------
#include <fs/fsMulticastTools/fsMulticastTools.h>
#include <mx/mxCore/mxString.h>
//------------------------------------------------------------------------------
class FSMULTICASTTOOLSCLASS fsMulticastAddress
{
public:
	fsMulticastAddress();
	~fsMulticastAddress();

public:
	enum AddressFamilyEnum {
		AF_IPv4,
		AF_IPv6,
		NUM_ADDRESSFAMILY
	};

public:

	/*
		IPv4 Address Range :  224.0.1.0 - 239.255.255.255
		IPv6 Address Range :  FF00:0:0:0:0:0:0:0 - FF00:FFFF:FFFF:FFFF:FFFF:FFFF:FFFF:FFFF:
	*/
	static mxString	createAddress(AddressFamilyEnum addressFamily);

private:
	static void		initRand();

private:
	static mxBool	_isInitRand;
};
//------------------------------------------------------------------------------
#endif //__fsMulticastAddress_h__
