/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#include "Stdafx.h"
#include <fs/fsMulticastTools/fsRMIProperty.h>
//------------------------------------------------------------------------------
fsRMIProperty::fsRMIProperty()
{
	_address			= "";
	_ports[PID_TRANSMIT]= 0;
	_ports[PID_RECEIVE]	= 0;
	_ttl				= 0;
	_packetSize			= 0;
	_transmissionRate	= 0;
	_transmissionCount	= 0;
	_invokeTimeout		= 0;
}
//------------------------------------------------------------------------------
fsRMIProperty::~fsRMIProperty()
{
}
//------------------------------------------------------------------------------
void
fsRMIProperty::setAddress(const mxString& address)
{
	_address = address;
}
//------------------------------------------------------------------------------
const mxString&
fsRMIProperty::getAddress() const
{
	return _address;
}
//------------------------------------------------------------------------------
void
fsRMIProperty::setPort(PortIDEnum portID, mxUShort port)
{
	_ports[portID] = port;
}
//------------------------------------------------------------------------------
mxUShort
fsRMIProperty::getPort(PortIDEnum portID) const
{
	return _ports[portID];
}
//------------------------------------------------------------------------------
void
fsRMIProperty::setTimeToLive(mxULong ttl)
{
	_ttl = ttl;
}
//------------------------------------------------------------------------------
mxULong
fsRMIProperty::getTimeToLive() const
{
	return _ttl;
}
//------------------------------------------------------------------------------
void
fsRMIProperty::setPacketSize(mxUInt size)
{
	_packetSize = size;
}
//------------------------------------------------------------------------------
mxUInt
fsRMIProperty::getPacketSize() const
{
	return _packetSize;
}
//------------------------------------------------------------------------------
void
fsRMIProperty::setMaximumTransmissionRate(mxUInt rate)
{
	_transmissionRate = rate;
}
//------------------------------------------------------------------------------
mxUInt
fsRMIProperty::getMaximumTransmissionRate() const
{
	return _transmissionRate;
}
//------------------------------------------------------------------------------
void
fsRMIProperty::setTransmissionCount(mxUInt count)
{
	_transmissionCount = count;
}
//------------------------------------------------------------------------------
mxUInt
fsRMIProperty::getTransmissionCount() const
{
	return _transmissionCount;
}
//------------------------------------------------------------------------------
void
fsRMIProperty::setInvokeTimeout(mxUInt timeout)
{
	_invokeTimeout = timeout;
}
//------------------------------------------------------------------------------
mxUInt
fsRMIProperty::getInvokeTimeout() const
{
	return _invokeTimeout;
}
//------------------------------------------------------------------------------
