/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef	__mxCriticalSection_h__
#define	__mxCriticalSection_h__
//------------------------------------------------------------------------------
#include <mx/mxCore/mxCore.h>
//------------------------------------------------------------------------------
class MXCORECLASS mxCriticalSection
{
public:
	mxCriticalSection();
	~mxCriticalSection();

public:
	void		enter() const;
	void		leave() const;

private:
	mxCriticalSection(const mxCriticalSection&);
	mxCriticalSection& operator =(const mxCriticalSection&);

private:
	mutable CRITICAL_SECTION	_csection;
};
//------------------------------------------------------------------------------
#endif	// !__mxCriticalSection_h__
