/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------
#ifndef __fsFlowLayout_h__
#define __fsFlowLayout_h__
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
//---------------------------------------------------------------------------
class fsFlowLayout
{
public:
	fsFlowLayout();
    virtual ~fsFlowLayout();

public:
	void	setMargin(int margin);
    int		getMargin() const;

	void	setGap(int vgap, int hgap);
    void	getGap(int&vgap, int&hgap) const;

public:
	void	doLayout(TScrollBox *scrollBox);

protected:
	int		_vgap;
    int		_hgap;
    int		_margin;
};
//---------------------------------------------------------------------------
#endif //__fsFlowLayout_h__

