/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------

#ifndef fsVolumeIndicatorTimerH
#define fsVolumeIndicatorTimerH
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
class TVolumeIndicatorTimer : public TThread
{
private:
protected:
	void __fastcall Execute();
public:
	__fastcall TVolumeIndicatorTimer();
	virtual __fastcall ~TVolumeIndicatorTimer();

public:
	typedef void __fastcall (__closure *TVTEvent)(System::TObject* Sender);

    __property bool Pause = { read = _pause, write = _pause, default = false };
    __property long Interval = { read = _interval, write = _interval, default = 10 };
    __property TVTEvent VolumePerform = { read = _volumePerform, write = _volumePerform, default = NULL };

private:
	bool 		_pause;
	long		_interval;
	TVTEvent 	_volumePerform;
};
//---------------------------------------------------------------------------
#endif
