/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------

#ifndef fsMulticastSettingFormH
#define fsMulticastSettingFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------
class TMulticastSettingForm : public TForm
{
__published:	// IDE Ǘ̃R|[lg
	TGroupBox *AddressGroupBox;
	TEdit *AddressEdit;
	TBitBtn *CreateIPv6AddressButton;
	TBitBtn *AddressUpdateButton;
	TBitBtn *CreateIPv4AddressButton;
	TLabel *TTLLabel;
	TEdit *TTLEdit;
	TUpDown *TTLUpDown;
	TBitBtn *TTLUpdateButton;
	void __fastcall FormShow(TObject *Sender);
	void __fastcall FormHide(TObject *Sender);
	void __fastcall AddressEditChange(TObject *Sender);
	void __fastcall TTLEditChange(TObject *Sender);
private:	// [U[錾
public:		// [U[錾
	__fastcall TMulticastSettingForm(TComponent* Owner);

	void	updateForm();

	bool		_formShown;
    bool    	_addressIsDirty;
    bool    	_timeToLiveIsDirty;
};
//---------------------------------------------------------------------------
extern PACKAGE TMulticastSettingForm *MulticastSettingForm;
//---------------------------------------------------------------------------
#endif
