/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------

#ifndef fsMultiReceiverMainFormH
#define fsMultiReceiverMainFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>

#include <ui/fsCommonUI/fsFlowLayout.h>
//---------------------------------------------------------------------------
class fsLanguage;
//---------------------------------------------------------------------------
class TMultiReceiverMainForm : public TForm
{
__published:	// IDE Ǘ̃R|[lg
	TStatusBar *StatusBar;
	TScrollBox *VideoRenderBaseScrollBox;
	void __fastcall VideoRenderBaseScrollBoxResize(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall FormCreate(TObject *Sender);
    void __fastcall VideoRenderBaseScrollBoxClick(TObject *Sender);
    void __fastcall FormKeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
	void __fastcall FormDestroy(TObject *Sender);
private:	// [U[錾
public:		// [U[錾
	__fastcall TMultiReceiverMainForm(TComponent* Owner);

    void __fastcall PanelClick(TObject *Sender);
    void __fastcall	LabelClick(TObject *Sender);

	int		ProcessCallback(const char *command, void *param);

public:
    bool    addMediaReceiver(const AnsiString& address);
    bool    removeMediaReceiver(int index);

    void	resizePanel(int index);
    void	resizePanelAll();

    TPanel* insertMediaReceiverBasePanel(const AnsiString& address);

    void	scrollAndSelect(int index);

private:
	void			toCenter(TForm* form);

public:
    fsLanguage*		_language;
	fsFlowLayout*  	_flowLayout;
};
//---------------------------------------------------------------------------
extern PACKAGE TMultiReceiverMainForm *MultiReceiverMainForm;
//---------------------------------------------------------------------------
#endif
