/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "fsMulticastSettingForm.h"
#include "fsMainDataModule.h"
#include <fs/fsMultiReceiver/fsMultiReceiverInterface.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMulticastSettingForm *MulticastSettingForm;
//---------------------------------------------------------------------------
__fastcall TMulticastSettingForm::TMulticastSettingForm(TComponent* Owner)
	: TForm(Owner)
{
	_formShown = false;
}
//---------------------------------------------------------------------------
void __fastcall
TMulticastSettingForm::FormShow(TObject *Sender)
{
	updateForm();

    _addressIsDirty		= false;
    _timeToLiveIsDirty	= false;

    _formShown = true;
}
//---------------------------------------------------------------------------
void __fastcall
TMulticastSettingForm::FormHide(TObject *Sender)
{
	_formShown = false;
}
//---------------------------------------------------------------------------
void __fastcall
TMulticastSettingForm::AddressEditChange(TObject *Sender)
{
	if (!_formShown)
		return;

    _addressIsDirty = true;
}
//---------------------------------------------------------------------------
void __fastcall
TMulticastSettingForm::TTLEditChange(TObject *Sender)
{
	_timeToLiveIsDirty = true;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void
TMulticastSettingForm::updateForm()
{
	AddressEdit->Text = fsMultiReceiverGetAddress();
    TTLEdit->Text = AnsiString(fsMultiReceiverGetTimeToLive());
}
//---------------------------------------------------------------------------
