/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------

#ifndef fsVideoSelectionFormH
#define fsVideoSelectionFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
//---------------------------------------------------------------------------
class TIndexStringEntry : public TObject
{
public:
	__fastcall TIndexStringEntry(int index, const AnsiString& string)
    {
    	this->index		= index;
		this->string	= string;
    }
public:
   	int			index;
    AnsiString  string;
};
//---------------------------------------------------------------------------
class TVideoSelectionForm : public TForm
{
__published:	// IDE Ǘ̃R|[lg
	TGroupBox *SelectCaptionGroupBox;
	TGroupBox *SelectAddressGroupBox;
	TListBox *SelectCaptionList;
	TListBox *SelectAddressList;
	void __fastcall SelectCaptionListClick(TObject *Sender);
	void __fastcall SelectAddressListClick(TObject *Sender);
private:	// [U[錾
public:		// [U[錾
	__fastcall TVideoSelectionForm(TComponent* Owner);
    __fastcall ~TVideoSelectionForm();

public:
	void	beginList();
    void	endList();
    void	addCaption(int index, const AnsiString& caption);
    void	addAddress(int index, const AnsiString& address);

protected:
	TObjectList*		_captionList;
    TObjectList*		_addressList;
    int					_captionSelectIndex;
    int					_addressSelectIndex;
};
//---------------------------------------------------------------------------
extern PACKAGE TVideoSelectionForm *VideoSelectionForm;
//---------------------------------------------------------------------------
#endif
