/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------

#ifndef fsPointerSettingFormH
#define fsPointerSettingFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------
class TPointerSettingForm : public TForm
{
__published:	// IDE Ǘ̃R|[lg
	TGroupBox *PointerCoordinateGroupBox;
	TRadioButton *PointerCoordinateDesktopWindowRadio;
	TRadioButton *PointerCoordinateVideoWindowRadio;
	TGroupBox *PointerSettingGroupBox;
	TComboBox *PointerSelectionComboBox;
	TLabel *PointerShapeLabel;
	TComboBox *PointerShapeComboBox;
	TLabel *PointerColorLabel;
	TLabel *PointerColorRLabel;
	TLabel *PointerColorGLabel;
	TLabel *PointerColorBLabel;
	TEdit *PointerColorREdit;
	TEdit *PointerColorGEdit;
	TEdit *PointerColorBEdit;
	TUpDown *PointerColorRUpDown;
	TUpDown *PointerColorGUpDown;
	TUpDown *PointerColorBUpDown;
	TLabel *PointerPhraseLabel;
	TComboBox *PointerPhraseComboBox;
	TButton *PointerColorChooseButton;
	void __fastcall FormShow(TObject *Sender);
	void __fastcall PointerShapeComboBoxChange(TObject *Sender);
	void __fastcall PointerColorREditChange(TObject *Sender);
	void __fastcall PointerColorGEditChange(TObject *Sender);
	void __fastcall PointerColorBEditChange(TObject *Sender);
	void __fastcall FormHide(TObject *Sender);
	void __fastcall PointerSelectionComboBoxChange(TObject *Sender);
	void __fastcall PointerPhraseComboBoxKeyPress(TObject *Sender, char &Key);
	void __fastcall PointerPhraseComboBoxClick(TObject *Sender);
private:	// [U[錾
public:		// [U[錾
	__fastcall TPointerSettingForm(TComponent* Owner);

public:
    void		updateForm();

private:
	bool	_formShown;
    int		_currentPointer;
};
//---------------------------------------------------------------------------
extern PACKAGE TPointerSettingForm *PointerSettingForm;
//---------------------------------------------------------------------------
#endif
