/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "fsCaptionSettingForm.h"
#include "fsMainDataModule.h"
#include <fs/fsSenderRemote/fsSenderRemoteInterface.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TCaptionSettingForm *CaptionSettingForm;
//---------------------------------------------------------------------------
__fastcall TCaptionSettingForm::TCaptionSettingForm(TComponent* Owner)
	: TForm(Owner)
{
	_formShown = false;
}
//---------------------------------------------------------------------------
void __fastcall
TCaptionSettingForm::FormShow(TObject *Sender)
{
	updateForm();
	_captionIsDirty = false;
    _formShown = true;
}
//---------------------------------------------------------------------------
void __fastcall
TCaptionSettingForm::FormHide(TObject *Sender)
{
    _formShown = false;
}
//---------------------------------------------------------------------------
void __fastcall
TCaptionSettingForm::CaptionEditChange(TObject *Sender)
{
	_captionIsDirty = true;
}
//---------------------------------------------------------------------------
void __fastcall
TCaptionSettingForm::CaptionEditKeyPress(TObject *Sender, char &Key)
{
	if (Key == VK_RETURN)
    {
        MainDataModule->setupCaption(CaptionEdit->Text);
	    MainDataModule->updateCaptionHistory();

    	Close();
    }
    else if (Key == VK_ESCAPE)
    {
    	Close();
    }
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void
TCaptionSettingForm::updateForm()
{
	AnsiString str = AnsiString(fsSenderGetCaption());
    if (str.Length() == 0)
	    CaptionEdit->Text = "";
    else
    	CaptionEdit->Text = str;

    CaptionEdit->SetFocus();

    _captionOff = !fsSenderGetCaptionOn();

    //
    // Actions
    //
    MainDataModule->CaptionOffAction->Checked = _captionOff;
    CaptionOffCheckBox->Enabled = false;
	CaptionOffCheckBox->Checked = _captionOff;
    CaptionOffCheckBox->Enabled = true;
}
//---------------------------------------------------------------------------

