/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------

#ifndef fsFocusDisplaySettingFormH
#define fsFocusDisplaySettingFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------
class TFocusDisplaySettingForm : public TForm
{
__published:	// IDE Ǘ̃R|[lg
    TGroupBox *NonLinearZoomGroupBox;
    TLabel *NonLinearZoomResolutionLabel;
    TComboBox *NonLinearZoomResolutionComboBox;
    TLabel *NonLinearZoomMaskSizeLabel;
    TLabel *NonLinearZoomMaskWidthLabel;
    TLabel *NonLinearZoomMaskHeightLabel;
    TLabel *NonLinearZoomMaskLabel;
    TComboBox *NonLinearZoomMaskComboBox;
    TGroupBox *ImageCompoundGroupBox;
    TLabel *ImageCompoundBaseResolutionLabel;
    TComboBox *ImageCompoundBaseResolutionComboBox;
    TLabel *ImageCompoundAddResolutionLabel;
    TComboBox *ImageCompoundAddResolutionComboBox;
    TLabel *ImageCompoundMaskLabel;
    TComboBox *ImageCompoundMaskComboBox;
    TLabel *ImageCompoundBlendingLabel;
    TComboBox *ImageCompoundBlendingComboBox;
	TEdit *NonLinearZoomMaskWidthEdit;
	TUpDown *NonLinearZoomMaskWidthUpDown;
	TEdit *NonLinearZoomMaskHeightEdit;
	TUpDown *NonLinearZoomMaskHeightUpDown;
	TGroupBox *PartialZoomGroupBox;
	TLabel *PartialZoomOutputResolutionLabel;
	TComboBox *PartialZoomOutputResolutionComboBox;
	TCheckBox *ShowFocusFrameCheckBox;
	TLabel *PartialZoomSourceResolutionLabel;
	TComboBox *PartialZoomSourceResolutionComboBox;
	TGroupBox *FocusCoordinateGroupBox;
	TRadioButton *FocusCoordinateDesktopWindowRadio;
	TRadioButton *FocusCoordinateVideoWindowRadio;
    void __fastcall NonLinearZoomResolutionComboBoxChange(TObject *Sender);
    void __fastcall NonLinearZoomMaskComboBoxChange(TObject *Sender);
    void __fastcall ImageCompoundBaseResolutionComboBoxChange(
          TObject *Sender);
    void __fastcall ImageCompoundAddResolutionComboBoxChange(
          TObject *Sender);
    void __fastcall ImageCompoundMaskComboBoxChange(TObject *Sender);
    void __fastcall ImageCompoundBlendingComboBoxChange(TObject *Sender);
    void __fastcall FormShow(TObject *Sender);
	void __fastcall NonLinearZoomMaskWidthEditChange(TObject *Sender);
	void __fastcall NonLinearZoomMaskHeightEditChange(TObject *Sender);
	void __fastcall PartialZoomOutputResolutionComboBoxChange(TObject *Sender);
	void __fastcall PartialZoomSourceResolutionComboBoxChange(TObject *Sender);
	void __fastcall FormHide(TObject *Sender);
private:	// [U[錾
public:		// [U[錾
    __fastcall TFocusDisplaySettingForm(TComponent* Owner);

public:
	void	updateForm();

public:
	bool _formShown;
};
//---------------------------------------------------------------------------
extern PACKAGE TFocusDisplaySettingForm *FocusDisplaySettingForm;
//---------------------------------------------------------------------------
#endif
