/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------

#ifndef fsMulticastSettingFormH
#define fsMulticastSettingFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------
class TMulticastSettingForm : public TForm
{
__published:	// IDE Ǘ̃R|[lg
	TLabel *TTLLabel;
	TLabel *TransmitCountLabel;
	TLabel *PacketSizeLabel;
	TEdit *PacketSizeEdit;
	TComboBox *TransmitCountComboBox;
	TBitBtn *TTLUpdateButton;
	TLabel *PacketSizeUnitLabel;
	TBitBtn *PacketSizeUpdateButton;
	TGroupBox *TransmitRateGroupBox;
	TComboBox *TransmitRateComboBox;
	TComboBox *TargetTransmitRateComboBox;
	TUpDown *PacketSizeUpDown;
	TEdit *TTLEdit;
	TUpDown *TTLUpDown;
	TGroupBox *AddressGroupBox;
	TEdit *AddressEdit;
	TBitBtn *CreateIPv6AddressButton;
	TBitBtn *CreateIPv4AddressButton;
	TBitBtn *AddressUpdateButton;
	TLabel *MulticastDetectLabel;
    void __fastcall FormShow(TObject *Sender);
	void __fastcall AddressEditChange(TObject *Sender);
	void __fastcall TTLEditChange(TObject *Sender);
	void __fastcall PacketSizeEditChange(TObject *Sender);
	void __fastcall TransmitCountComboBoxChange(TObject *Sender);
	void __fastcall TargetTransmitRateComboBoxChange(TObject *Sender);
	void __fastcall TransmitRateComboBoxClick(TObject *Sender);
	void __fastcall TransmitRateComboBoxKeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
	void __fastcall FormHide(TObject *Sender);
private:	// [U[錾
    bool    setupTransmissionRate(TComboBox *comboBox, int rate);
    void    setupTransmissionCount(TComboBox *comboBox, int count);
    int     getTransmissionRate(TComboBox *comboBox);
    int     getTransmissionCount(TComboBox *comboBox);

public:		// [U[錾
    __fastcall TMulticastSettingForm(TComponent* Owner);

public:
	void	updateForm();

public:
	bool		_formShown;
    bool    	_addressIsDirty;
    bool    	_ttlIsDirty;
    bool    	_packetSizeIsDirty;
    AnsiString	_inputAddress;
};
//---------------------------------------------------------------------------
extern PACKAGE TMulticastSettingForm *MulticastSettingForm;
//---------------------------------------------------------------------------
#endif
